# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Summary:	Information about Perl modules
Name:		perl-Module-Info
Version:	0.39
Release:	1.%{__distinit}%{__distvers}
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Module-Info
Source0:	https://cpan.metacpan.org/modules/by-module/Module/Module-Info-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(B::Utils) >= 0.27
BuildRequires:	perl(Carp)
BuildRequires:	perl(Config)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(Safe)
BuildRequires:	perl(strict)
BuildRequires:	perl(version)
BuildRequires:	perl(warnings)
# Script Runtime
BuildRequires:	perl(Getopt::Long)
# Test Suite
BuildRequires:	perl(Class::Struct)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(lib)
BuildRequires:	perl(threads)
BuildRequires:	perl(threads::shared)
BuildRequires:	perl(vars)
# Optional Tests
BuildRequires:	perl(Test::Pod) >= 1.00
# Release Tests
BuildRequires:	perl(Test::Pod::Coverage) >= 1.00
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(IPC::Open3)
Requires:	perl(Safe)
Requires:	perl(version)

%description
Module::Info gives you information about Perl modules without actually loading
the module. It isn't actually specific to modules and should work on any perl
code.

%prep
%setup -q -n Module-Info-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test RELEASE_TESTING=1

%files
%doc Changes
%{_bindir}/module_info
%{_bindir}/pfunc
%{perl_vendorlib}/B/
%{perl_vendorlib}/Module/
%{_mandir}/man1/module_info.1*
%{_mandir}/man1/pfunc.1*
%{_mandir}/man3/B::Module::Info.3*
%{_mandir}/man3/Module::Info.3*

%changelog
* Wed Aug 28 2024 Paul Howarth <paul@city-fan.org> - 0.39-1
- Update to 0.39
  - Get rid of ' as package namespace separator
  - Fixed compatibility with 5.8.1 (CPAN RT#129677)

* Tue Jul 18 2023 Paul Howarth <paul@city-fan.org> - 0.37-22
- Use SPDX-format license tag
- Switch upstream from search.cpan.org to metacpan.org

* Thu Apr 26 2018 Paul Howarth <paul@city-fan.org> - 0.37-7
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Tue Sep  6 2016 Paul Howarth <paul@city-fan.org> - 0.37-3
- BR: perl-generators where available
- Simplify find command using -delete

* Mon Nov  2 2015 Paul Howarth <paul@city-fan.org> - 0.37-1
- Update to 0.37
  - Added a has_pod() method, which returns the path to the file containing
    the pod (it could be a .pod file), if there is one
  - Listed NEILB as the current maintainer in the AUTHOR section
  - Added link to github repo to doc

* Mon Oct 26 2015 Paul Howarth <paul@city-fan.org> - 0.36-1
- Update to 0.36
  - Dropped our own fork of B::Utils, now rely on CPAN one (CPAN RT#13524)
  - Now works on recent versions of Perl (CPAN RT#97105)
  - Pod tests not run on installation (CPAN RT#90599)
- This release by NEILB → update source URL
- Drop now-redundant provides filter

* Sun Jun 21 2015 Paul Howarth <paul@city-fan.org> - 0.35-7
- Fixed bundled B::Utils to build with Perl 5.22
- Classify buildreqs by usage

* Sun Aug 31 2014 Paul Howarth <paul@city-fan.org> - 0.35-4
- Drop %%defattr, redundant since rpm 4.4

* Sun Sep  8 2013 Paul Howarth <paul@city-fan.org> - 0.35-1
- Update to 0.35
  - Handle 'package NAME VERSION' syntax
  - Added repository and license info to metadata
  - Tweaked format of Changes file to match CPAN::Changes::Spec
- B::Module::Info manpage always shipped now

* Wed Jul 17 2013 Paul Howarth <paul@city-fan.org> - 0.34-2
- Perl 5.18 rebuild

* Tue May 21 2013 Paul Howarth <paul@city-fan.org> - 0.34-1
- Update to 0.34
  - Replace Text::Soundex in tests with Class::Struct, since Text::Soundex will
    not be in core in Perl 5.19 and up
  - Replace ExtUtils::MY_Metafile with META_MERGE in Makefile.PL

* Sun Feb 10 2013 Paul Howarth <paul@city-fan.org> - 0.33-2
- Don't provide perl(B::Utils)

* Sun Feb 10 2013 Paul Howarth <paul@city-fan.org> - 0.33-1
- Update to 0.33
  - Fix tests under Perl 5.6.2 when some core modules have been upgraded
- BR: perl(Text::Soundex)

* Fri Jun 29 2012 Paul Howarth <paul@city-fan.org> - 0.32-5
- BR:/R: perl(Safe) and perl(version)
- BR: perl(Carp), perl(Cwd), perl(File::Spec), perl(lib), perl(Test::Builder),
  perl(Test::More)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Fri Jul  1 2011 Paul Howarth <paul@city-fan.org> - 0.32-3
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Sep  9 2010 Paul Howarth <paul@city-fan.org> - 0.32-1
- Update to 0.32
  - Add archlib and privlib to the search path for core modules

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 0.31-9
- Rebuild for perl 5.12.1 in Rawhide

* Fri Jun  4 2010 Paul Howarth <paul@city-fan.org> - 0.31-5
- Fix dist tag for RHEL-6 Beta

* Sun Feb 28 2010 Paul Howarth <paul@city-fan.org> - 0.31-4
- Dist tag for Rawhide no longer needs special-casing

* Mon Sep 21 2009 Paul Howarth <paul@city-fan.org> - 0.31-3
- Define RPM macros in global scope

* Sat Nov  1 2008 Paul Howarth <paul@city-fan.org> - 0.31-2
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)
- Buildreq perl(ExtUtils::MakeMaker)

* Thu May 31 2007 Paul Howarth <paul@city-fan.org> - 0.31-1
- Update to 0.31
- Fix dist tag for Fedora 7 onwards
- Fix argument order for find with -depth
- Add buildreq perl(Test::Pod::Coverage) for improved testing
  Note: some tests are skipped if perl(version) is installed and other tests
  are skipped if it is not, so there is no point adding perl(version) as a
  buildreq

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> - 0.30-2
- Fix distribution tags for development releases

* Wed Dec 21 2005 Paul Howarth <paul@city-fan.org> - 0.30-1
- Update to 0.30

* Thu Nov 24 2005 Paul Howarth <paul@city-fan.org> - 0.290-1
- Update to 0.290
- Use search.cpan.org URLs
- Don't use macros in paths for build-time commands, hardcode them instead
- Simplify distribution-detection
- Remove redundant macro definitions
- Buildreq perl(Test::Pod) >= 1.18 for better test cover
  (fails with Test::Pod 1.16 by the way)
- Remove buildroot unconditionally in %%clean and %%install

* Mon Jul 11 2005 Paul Howarth <paul@city-fan.org> - 0.28-2
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Wed Apr 20 2005 Paul Howarth <paul@city-fan.org> - 0.28-1
- Update to 0.28

* Wed Mar  9 2005 Paul Howarth <paul@city-fan.org> - 0.27-1
- Update to 0.27
- Update URL

* Wed Oct 27 2004 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26
- Tidy up spec file

* Mon May 10 2004 Paul Howarth <paul@city-fan.org> - 0.24-1
- Initial build
